"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Bars = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _chart = _interopRequireDefault(require("chart.js"));

var R = _interopRequireWildcard(require("ramda"));

var _transforms = require("../transforms");

var _dataUtils = require("../data-utils");

var _Chart = require("./Chart");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable fp/no-mutation, fp/no-mutating-methods */
var propTypes = {
  data: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  type: _propTypes["default"].string,
  options: _propTypes["default"].objectOf(_propTypes["default"].any),
  point: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var chartColors = ['rgb(50, 152, 235)', 'rgb(255, 159, 64)', 'rgb(75, 185, 92)', 'rgb(153, 102, 255)', 'rgb(255, 99, 99)', 'rgb(255, 205, 86)', 'rgb(190, 90, 60)', 'rgb(231, 80, 200)', 'rgb(60, 203, 180)', 'rgb(255, 20, 0)', 'rgb(201, 203, 207)'];
var defaultCanvasStyle = {
  width: 300,
  height: 300
};

var getDefaultDataset = function getDefaultDataset() {
  return {
    fill: false,
    backgroundColor: chartColors,
    borderColor: chartColors,
    borderWidth: 0
  };
};

var getDefaultOptions = function getDefaultOptions() {
  return _objectSpread({}, _Chart.commonOptions, {
    legend: {
      display: false
    }
  });
};

var Bars = function Bars(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === void 0 ? _dataUtils.emptyObj : _ref$style,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'bar' : _ref$type,
      _ref$data = _ref.data,
      data = _ref$data === void 0 ? _dataUtils.emptyObj : _ref$data,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? _dataUtils.emptyObj : _ref$options,
      point = _ref.point;
  var canvasRef = (0, _react.useRef)(null);
  var chart = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    // console.log('Bars init:', type, data, options, point, ttl);
    if (chart.current) return;
    var chartData = (0, _Chart.initChartDataFromData)([getDefaultDataset()])(data);
    chart.current = new _chart["default"](canvasRef.current, {
      type: type,
      data: chartData,
      options: R.mergeDeepLeft(options, getDefaultOptions())
    });
  }, [data, options, type]);
  (0, _react.useEffect)(function () {
    var _datasetHandle$data;

    // console.log('Bars useEffect point:', point);
    if ((0, _transforms.nilOrEmpty)(point)) return;
    var datasetHandle = chart.current.data.datasets[0];

    (_datasetHandle$data = datasetHandle.data).splice.apply(_datasetHandle$data, [0, datasetHandle.data.length].concat(_toConsumableArray(point.pl)));

    if ((0, _transforms.nilOrEmpty)(datasetHandle.labels)) datasetHandle.labels = _toConsumableArray(point.pl);
    chart.current.update();
  }, [point]);

  var canvasStyle = _objectSpread({}, defaultCanvasStyle, {}, style);

  return (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement("canvas", {
      // id={chartId}
      ref: canvasRef,
      width: canvasStyle.width,
      height: canvasStyle.height,
      style: canvasStyle
    });
  }, [canvasStyle]);
};

exports.Bars = Bars;
Bars.propTypes = propTypes;