"use strict";

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _core = require("@material-ui/core");

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

var _dataUtils = require("../data-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    actionButton: {
      position: 'relative'
    },
    cancelButton: {
      position: 'relative'
    },
    button: {
      margin: theme.spacing(1),
      marginLeft: 0
    },
    icon: {
      marginLeft: theme.spacing(1)
    }
  };
});
var propTypes = {
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  firstButtonText: _propTypes["default"].string.isRequired,
  secondButtonText: _propTypes["default"].string.isRequired,
  editingOn: _propTypes["default"].bool.isRequired,
  disabled: _propTypes["default"].bool.isRequired,
  onEditingOn: _propTypes["default"].func.isRequired,
  onSave: _propTypes["default"].func.isRequired,
  onCancel: _propTypes["default"].func.isRequired
};

var EditCancelSaveButtons = function EditCancelSaveButtons(_ref) {
  var editingOn = _ref.editingOn,
      onSave = _ref.onSave,
      onCancel = _ref.onCancel,
      onEditingOn = _ref.onEditingOn,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? _dataUtils.emptyObj : _ref$style,
      firstButtonText = _ref.firstButtonText,
      secondButtonText = _ref.secondButtonText,
      disabled = _ref.disabled;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    variant: "contained",
    className: classes.button,
    color: "primary",
    type: "submit",
    onClick: editingOn ? onSave : onEditingOn,
    disabled: disabled
  }, firstButtonText, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
    className: classes.icon
  }, editingOn ? 'save' : 'edit')), editingOn && /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    variant: "contained",
    className: classes.button,
    onClick: onCancel
  }, secondButtonText, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
    className: classes.icon
  }, "clear")));
};

EditCancelSaveButtons.propTypes = propTypes;