function _typeof(obj) {
  '@babel/helpers - typeof';

  if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj &&
        typeof Symbol === 'function' &&
        obj.constructor === Symbol &&
        obj !== Symbol.prototype
        ? 'symbol'
        : typeof obj;
    };
  }
  return _typeof(obj);
}

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.Notifications = void 0;

const _react = _interopRequireWildcard(require('react'));

const _propTypes = _interopRequireDefault(require('prop-types'));

const _core = require('@material-ui/core');

const _Divider = _interopRequireDefault(require('@material-ui/core/Divider'));

const _Collapse = _interopRequireDefault(require('@material-ui/core/Collapse'));

const _Icon = _interopRequireDefault(require('@material-ui/core/Icon'));

const _Typography = _interopRequireDefault(require('@material-ui/core/Typography'));

const R = _interopRequireWildcard(require('ramda'));

const _fp = require('date-fns/fp');

const _dmUtils = require('../dm-utils');

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

function _getRequireWildcardCache() {
  if (typeof WeakMap !== 'function') return null;
  const cache = new WeakMap();
  _getRequireWildcardCache = function _getRequireWildcardCache() {
    return cache;
  };
  return cache;
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (_typeof(obj) !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  const cache = _getRequireWildcardCache();
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  const newObj = {};
  const hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (const key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      const desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}

function _slicedToArray(arr, i) {
  return (
    _arrayWithHoles(arr) ||
    _iterableToArrayLimit(arr, i) ||
    _unsupportedIterableToArray(arr, i) ||
    _nonIterableRest()
  );
}

function _nonIterableRest() {
  throw new TypeError(
    'Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.',
  );
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === 'string') return _arrayLikeToArray(o, minLen);
  let n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === 'Object' && o.constructor) n = o.constructor.name;
  if (n === 'Map' || n === 'Set') return Array.from(n);
  if (n === 'Arguments' || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === 'undefined' || !(Symbol.iterator in Object(arr))) return;
  const _arr = [];
  let _n = true;
  let _d = false;
  let _e;
  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i.return != null) _i.return();
    } finally {
      if (_d) throw _e;
    }
  }
  return _arr;
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

const severityMap = {
  none: {
    icon: 'chat_bubble_outline',
  },
  minor: {
    icon: 'announcement',
  },
  major: {
    icon: 'warning',
    color: 'orange',
  },
  critical: {
    icon: 'report',
    color: 'red',
  },
  success: {
    icon: 'chat_bubble_outline',
  },
  info: {
    icon: 'announcement',
  },
  warning: {
    icon: 'warning',
    color: 'orange',
  },
  error: {
    icon: 'report',
    color: 'red',
  },
};
const useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    wrapper: {
      overflowY: 'auto',
      overflowX: 'hidden',
      height: '100%',
    },
    icon: {
      alignSelf: 'center',
      paddingRight: theme.spacing(2),
    },
    text: {
      paddingLeft: 12,
    },
  };
});
const propTypes = {
  messages: _propTypes.default.arrayOf(_propTypes.default.any),
  style: _propTypes.default.objectOf(_propTypes.default.any),
};
const defaultProps = {
  style: {},
  messages: [],
};

const Notification = function Notification(_ref) {
  const { msg } = _ref;

  const _useState = (0, _react.useState)(false);
  const _useState2 = _slicedToArray(_useState, 2);
  const expanded = _useState2[0];
  const setExpanded = _useState2[1];

  const classes = useStyles();
  (0, _react.useEffect)(function () {
    setTimeout(function () {
      return setExpanded(true);
    }, 10);
  }, []);
  const _msg$ts = msg.ts;
  const ts = _msg$ts === void 0 ? (0, _dmUtils.dateToTs)(new Date()) : _msg$ts;
  const _msg$pl = msg.pl;
  const pl = _msg$pl === void 0 ? [{}] : _msg$pl;
  const _pl$ = pl[0];
  const _pl$$signal = _pl$.signal;
  const signal = _pl$$signal === void 0 ? 'Unknown' : _pl$$signal;
  const _pl$$severity = _pl$.severity;
  const severity = _pl$$severity === void 0 ? 'none' : _pl$$severity;
  const iConf = severityMap[severity] || severityMap.none;
  return /* #__PURE__ */ _react.default.createElement(
    _Collapse.default,
    {
      in: expanded,
    },
    /* #__PURE__ */ _react.default.createElement(
      'div',
      {
        style: {
          display: 'flex',
          padding: '12px 6px 12px 12px',
        },
      },
      /* #__PURE__ */ _react.default.createElement(
        _Icon.default,
        {
          className: classes.icon,
          style: iConf.color && {
            color: iConf.color,
          },
        },
        iConf.icon,
      ),
      /* #__PURE__ */ _react.default.createElement(
        'div',
        {
          className: classes.text,
        },
        /* #__PURE__ */ _react.default.createElement(_Typography.default, null, signal),
        /* #__PURE__ */ _react.default.createElement(
          _Typography.default,
          {
            variant: 'caption',
          },
          (0, _fp.format)('d MMM HH:mm')((0, _dmUtils.tsToDate)(ts)),
        ),
      ),
    ),
  );
};

Notification.propTypes = {
  msg: _propTypes.default.objectOf(_propTypes.default.any).isRequired,
};

const Notifications = function Notifications(_ref2) {
  const { style } = _ref2;
  const { messages } = _ref2;
  const classes = useStyles(); // console.log('Notifications', messages);

  return /* #__PURE__ */ _react.default.createElement(
    'div',
    {
      style,
      className: classes.wrapper,
    },
    /* #__PURE__ */ _react.default.createElement(_Divider.default, null),
    R.compose(
      R.map(function (msg) {
        return /* #__PURE__ */ _react.default.createElement(
          'div',
          {
            key: JSON.stringify(msg),
          },
          /* #__PURE__ */ _react.default.createElement(Notification, {
            classes,
            msg,
          }),
          /* #__PURE__ */ _react.default.createElement(_Divider.default, null),
        );
      }),
      R.reverse,
      R.when(function (m) {
        return !Array.isArray(m);
      }, R.of),
    )(messages),
  );
};

exports.Notifications = Notifications;
Notifications.propTypes = propTypes;
Notifications.defaultProps = defaultProps;
