"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PageC = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDocumentTitle = _interopRequireDefault(require("react-document-title"));

var _core = require("@material-ui/core");

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _dataUtils = require("../data-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  title: _propTypes["default"].string,
  topBar: _propTypes["default"].node,
  noPaperBg: _propTypes["default"].bool,
  children: _propTypes["default"].node.isRequired,
  paperBgStyle: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    toolbar: theme.mixins.toolbar,
    bg: {
      width: '100vw',
      minHeight: '100vh',
      position: 'fixed',
      zIndex: -1
    }
  };
});

var PageC = function PageC(_ref) {
  var _ref$title = _ref.title,
      title = _ref$title === void 0 ? '' : _ref$title,
      children = _ref.children,
      noPaperBg = _ref.noPaperBg,
      _ref$paperBgStyle = _ref.paperBgStyle,
      paperBgStyle = _ref$paperBgStyle === void 0 ? _dataUtils.emptyObj : _ref$paperBgStyle,
      topBar = _ref.topBar;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement(_reactDocumentTitle["default"], {
    title: title
  }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, !noPaperBg && /*#__PURE__*/_react["default"].createElement(_Paper["default"], {
    elevation: 0,
    className: classes.bg,
    style: paperBgStyle
  }), topBar, topBar && /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.toolbar
  }), children));
};

exports.PageC = PageC;
PageC.propTypes = propTypes;