"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThresholdGaugeTS = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _formatDistance = _interopRequireDefault(require("date-fns/fp/formatDistance"));

var _transforms = require("../transforms");

var _Caption = require("./Caption");

var _ThresholdGauge = require("./ThresholdGauge");

var _useUpdateTrigger = require("../hooks/useUpdateTrigger");

var _dataUtils = require("../data-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useStyles = (0, _core.makeStyles)(function () {
  return {
    center: {
      textAlign: 'center'
    },
    flexCenter: {
      justifyContent: 'center',
      display: 'flex',
      flexDirection: 'column'
    }
  };
});
var propTypes = {
  msg: _propTypes["default"].objectOf(_propTypes["default"].any),
  // Backward compatibility
  point: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  gaugeStyle: _propTypes["default"].objectOf(_propTypes["default"].any),
  path: _propTypes["default"].string // ThresholdGaugeProps: PropTypes.objectOf(PropTypes.any),

};

var ThresholdGaugeTS = function ThresholdGaugeTS(_ref) {
  var msg = _ref.msg,
      point = _ref.point,
      _ref$path = _ref.path,
      path = _ref$path === void 0 ? 'pl[0]' : _ref$path,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? _dataUtils.emptyObj : _ref$style,
      _ref$gaugeStyle = _ref.gaugeStyle,
      gaugeStyle = _ref$gaugeStyle === void 0 ? _dataUtils.emptyObj : _ref$gaugeStyle,
      rest = _objectWithoutProperties(_ref, ["msg", "point", "path", "style", "gaugeStyle"]);

  var classes = useStyles();
  var pointOnly = point || msg || _dataUtils.emptyObj;
  var ts = pointOnly.ts;
  (0, _useUpdateTrigger.useUpdateTrigger)({
    restartTrigger: ts
  });

  var timeLabel = /*#__PURE__*/_react["default"].createElement(_Caption.Caption, {
    label: "Data age: ".concat(ts ? (0, _formatDistance["default"])(new Date())(ts) : '-')
  });

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.flexCenter,
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_ThresholdGauge.ThresholdGauge, _extends({
    value: (0, _transforms.getPath)(path, pointOnly),
    style: gaugeStyle
  }, rest)), /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.center
  }, ts ? /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
    title: ts.toISOString()
  }, /*#__PURE__*/_react["default"].createElement("span", null, timeLabel)) : timeLabel));
};

exports.ThresholdGaugeTS = ThresholdGaugeTS;
ThresholdGaugeTS.propTypes = propTypes;